function PerifericosService(ZHPromise, ScreenService, PrinterService) {
	var header = {
		"Content-Type": "application/json"
	};
	var POST = "POST";

	//Recebe array de parametros para impressao.
	//Cada posicao deve conter informacoes necessarias
	//para realizar uma requisicao ao perifericos.

	this.print = function (params, impressaoPedidoSmart, imprimeNoFor) {
		var defer = ZHPromise.defer();
		try {
			ScreenService.showLoader();
			counter = 0;
			impressaoPedidoSmart = !_.isEmpty(impressaoPedidoSmart) ? impressaoPedidoSmart : params;
			if (params == false || (_.isEmpty(params) && _.isEmpty(impressaoPedidoSmart))){
				var res = {
						message: "",
						error: false
					};
				defer.resolve(res);
				return defer.promise;
			}
			if (params[0].saas) {
				var texto = '';
				if (!Util.isDesktop() && ((impressaoPedidoSmart[0].impressora.IDMODEIMPRES == '25' && !!window.cordova && !!cordova.plugins.GertecPrinter) || (impressaoPedidoSmart[0].impressora.IDMODEIMPRES == '27' && !!window.ZhCieloAutomation) || impressaoPedidoSmart[0].impressora.IDMODEIMPRES == '28')) {
					impressaoPedidoSmart.forEach(function(pedidos){
						pedidos.comandos.forEach(function(comandos){
							counter++;
							texto += comandos.parameters.text;
							if (!!~comandos.parameters.text.search('SENHA')) {
								PrinterService.printerCommand(PrinterService.TEXT_COMMAND, texto);
								PrinterService.printerSpaceCommand(2);
								texto = '';
							}
						});
					}.bind(this));
				}
				PrinterService.printerInit().then(function (result) {
					if (result.error) ScreenService.alertNotification(result.message);
				});
				var resu = {
					message: "",
					error: false
				};
				defer.resolve(resu);
				return defer.promise;
			} else {
				if (!Array.isArray(params)) {
					if (params.comandos) {
						params = [params];
					} else {
						params = _.toArray(params);
					}
				}
				var promiseArray = params.map(function (param) {
					if (!param.saas) {
						var url = param.impressora.DSIPPONTE + "/print";
						var body = JSON.stringify({
							printerInfo: {
								printerType: param.impressora.IDMODEIMPRES,
								port: param.impressora.CDPORTAIMPR
							},
							commands: param.comandos
						});

						return fetch(
							url, {
							headers: header,
							method: POST,
							body: body
						}
						);
					}
				});
				return Promise.all(promiseArray);
			}
		} catch (error) {
			if (!_.isEmpty(_.get(params, 'impressora.NMIMPRLOJA'))) {
				error.message = 'Não foi possível comunicar com a impressora. <br><br>' + params.impressora.NMIMPRLOJA + ' : Endereço do Periféricos inválido ou se encontra desligado.';
			} else {
				error.message = 'Não foi possível comunicar com a impressora. <br><br>' + params.NMIMPRLOJA + ' : Endereço do Periféricos inválido ou se encontra desligado.';
			}
			error.error = true;
			defer.reject(error);
			return defer.promise;
		} finally {
			ScreenService.hideLoader();
		}
	};

	this.printTableOrder = function (impressaoPedidoSmart) {
		var defer = ZHPromise.defer();
		try {
			ScreenService.showLoader();
			if (_.isEmpty(impressaoPedidoSmart)){
				var res = {
						message: "",
						error: false
					};
				defer.resolve(res);
				return defer.promise;
			}
			if (impressaoPedidoSmart[0].saas) {
				var texto = '';
				if (!Util.isDesktop() && ((impressaoPedidoSmart[0].impressora.IDMODEIMPRES == '25' && !!window.cordova && !!cordova.plugins.GertecPrinter) || (impressaoPedidoSmart[0].impressora.IDMODEIMPRES == '27' && !!window.ZhCieloAutomation) || impressaoPedidoSmart[0].impressora.IDMODEIMPRES == '28')) {
					for (var i in impressaoPedidoSmart){
						for (var j in impressaoPedidoSmart[i].comandos){
							texto += impressaoPedidoSmart[i].comandos[j].parameters.text;
							if (!!~impressaoPedidoSmart[i].comandos[j].parameters.text.search('SENHA')) {
								PrinterService.printerCommand(PrinterService.TEXT_COMMAND, texto);
								PrinterService.printerSpaceCommand(2);
								texto = '';
							}
						}
					}
				}
				var resu = {
					message: "",
					error: false
				};
				defer.resolve(resu);
				return defer.promise;
			}
		} catch (error) {
			if (!_.isEmpty(_.get(impressaoPedidoSmart, 'impressora.NMIMPRLOJA'))) {
				error.message = 'Não foi possível comunicar com a impressora. <br><br>' + impressaoPedidoSmart.impressora.NMIMPRLOJA + ' : Endereço do Periféricos inválido ou se encontra desligado.';
			} else {
				error.message = 'Não foi possível comunicar com a impressora. <br><br>' + impressaoPedidoSmart.NMIMPRLOJA + ' : Endereço do Periféricos inválido ou se encontra desligado.';
			}
			error.error = true;
			defer.reject(error);
			return defer.promise;
		} finally {
			ScreenService.hideLoader();
		}
	};

	this.test = function (params) {
		ScreenService.showLoader();
		var body = JSON.stringify({
			printerInfo: {
				printerType: params.IDMODEIMPRES,
				port: params.CDPORTAIMPR
			}
		});

		var options = {
			headers: header,
			method: POST,
			body: body
		};

		const url = params.DSIPPONTE + "/test";
		return fetch(url, options)
			.then(function (response) {
				response = response.text();
				try {
					response = JSON.parse(response);
				} catch (error) {
					response.message = 'Não foi possível comunicar com a impressora. <br><br>' + params.NMIMPRLOJA + ' : Endereço do Periféricos inválido ou se encontra desligado.';
					response.error = true;
				}
				return response;
			}).catch(function (error) {
				error.message = 'Não foi possível comunicar com a impressora. <br><br>' + params.NMIMPRLOJA + ' : Endereço do Periféricos inválido ou se encontra desligado.';
				error.error = true;
				return error;
			}).finally(function () {
				ScreenService.hideLoader();
			});
	};
}

Configuration(function (ContextRegister) {
	ContextRegister.register("PerifericosService", PerifericosService);
});